package com.napa.pulse.dao.impl;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.test.util.ReflectionTestUtils;

import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.Assert.assertNotNull;
import static org.mockito.ArgumentMatchers.*;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;
import static org.mockito.MockitoAnnotations.initMocks;

/**
 * @author Aqueel Ahmad
 * 20/10/2022
 */
@SpringBootTest
@RunWith ( MockitoJUnitRunner.class )
public class SessionAnalysisDAOImplUnitTest {
    @InjectMocks
    SessionAnalysisDAOImpl mockSessionAnalysisDAO;
    @Mock
    JdbcTemplate jdbcTemplate;
    @Before
    public void setUp ( ) {
        initMocks(this);
        jdbcTemplate = mock(JdbcTemplate.class);
    }
    @Test
    public void test_getExpensiveItem()
    {
        Integer expected = 0;
        mockSessionAnalysisDAO = new SessionAnalysisDAOImpl();
        ReflectionTestUtils.setField(mockSessionAnalysisDAO, "jdbcTemplate", jdbcTemplate);
        int sessionId = 277562;
        when(jdbcTemplate.queryForObject(anyString(), eq(Integer.class))).thenReturn(anyInt());
        Integer result= mockSessionAnalysisDAO.getExpensiveItem(sessionId);
        assertNotNull(result);
        assertThat(result).isEqualTo(expected);

    }

}
